(import openssl)
(import spiffy)
(import (chicken process-context))

(define (getenv key #!optional default)
  (or (get-environment-variable key) default))

(define port (getenv "SSL_PORT" 8443))
(define private-key (getenv "SSL_PRIVATE_KEY" "cert.key"))
(define public-key (getenv "SSL_PUBLIC_KEY" "cert.pem"))

(server-port port)
(define listener (ssl-listen* port: port
                              ;; protocol: 'tlsv1
                              ;; protocol: '(tlsv1 . tlsv12)
                              protocol: '(tlsv12 . tlsv13)
                              certificate: public-key
                              private-key: private-key))
(accept-loop listener ssl-accept)
